//******************************************
//		: ADת
// 			:
//ӷʽ	:
//			:
//******************************************
/*							Pin Assignment
*********************************************************************
..............................-----------............................
01.VSS......................01|    U    |20...VDD
02.P00/XIN..................02|         |19...P40/AIN0/KWI0/(P75/INT2)
03.P01/XOUT.................03| SOP-20  |18...P41/AIN1/KWI1/(P76/INT3)
04.P10/RESETB...............04| DIP-20  |17...P42/AIN2/KWI2
05.P71/TC01/PWM01B/PPG01B...05|         |16...P43/AIN3/KWI3/VREF
06.P90/TX...................06|         |15...P44/AIN4/KWI4
07.P91/RX...................07|         |14...P45/AIN5/KWI5
08.P72/TCA0/PPGA0B..........08|         |13...P74/DVOB/AIN8
09.P80/TC02/PWM02B..........09|         |12...P46/AIN6/KWI6/(P70/TC00/PWM00B/PPG00B)
10.P81/TC03/PWM03B..........10|         |11...P47/AIN7/KWI7/(P77/INT4)
..............................-----------............................
IO port change by SFR(PORTCFG<5:2>)
***	PORTCFG.bit.b2 ==> default 1=P47, and 0=P77
***	PORTCFG.bit.b3 ==> default 1=P46, and 0=P70
***	PORTCFG.bit.b4 ==> default 1=P41, and 0=P76
***	PORTCFG.bit.b5 ==> default 1=P40, and 0=P75
*********************************************************************/
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "MQ6801.h"
#include "ADC.h"



//-- ض庯 --//
#ifndef	uchar
#define uchar unsigned char
#endif
#ifndef	uint
#define uint  unsigned int
#endif
#ifndef	ulong
#define ulong unsigned long
#endif


//-- Define IO port --//
#define	look_SDA		P9DR.bit.b0
#define	look_SCL		P9DR.bit.b1



//-- 庯 --//
void delay_times(uchar tBase, uint x);
void look_data(uchar data);
void XTAL_High_Config();


extern uint  GetVref(void);
extern ulong ADC_ConvCode(uchar, uchar, uchar, uchar);
extern ulong ADC_ConvVolt(uchar, uchar, uchar, uchar);


//-- ȫֳ --//
const uchar t_1ms   = 0;
const uchar t_100us = 1;
const uchar t_6u    = 2;	//HIRC: 8MHz, CGCR/4
const uchar t_3u    = 3;	//HIRC:16MHz, CGCR/4


uint  ADC_Code_READ;
ulong ADC_VOLTAGE;
uchar data2Port[2];

uint  vref_l, vref_h;
ulong iReal_Vref2V, adc_value, adc_GND;



void main()
{
	uchar iloop;

//XTAL_High_Config();
//delay_times(t_1ms,100);
	WDCDR.byte = 0x4e;			// clear wdt
//	P90/P91(SDA/SCL) output for ADC result by IO_i2c
	P9DR.bit.b0 = 1;
	P9CR.bit.b0 = 1;
	P9DR.bit.b1 = 1;
	P9CR.bit.b1 = 1;
//	P80/P81 output monitor	// ۲ִʱ䣬ɾ 
	P8DR.bit.b0 = 0;
	P8CR.bit.b0 = 1;
	P8DR.bit.b1 = 0;
	P8CR.bit.b1 = 1;


//-----------------------------------
//	ִһΣȡڲVref 2V֮ʵֵ
//	MQ6801:ȡֵΪ ( ڲVref 2V֮ʵֵ ), λΪmV
	iReal_Vref2V = GetVref();
//	16ת, 
//	for( iloop=0; iloop<=(16/ad_test_times); iloop++ )
//		ADC_detect(Vref2, AIN_GND, Conv256CLK, ADC_Single);
//-----------------------------------
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
	while(1)
	{
		WDCDR.byte = 0x4e;			// clear wdt


		P8DR.bit.b0 = 1;	// ۲ִʱ䣬ɾ
//>>>>>>ADתʱ: ADC_ConvCode > ADC_ConvVolt(Ͽ)
//......................................................................................................
//------ADC_ConvVolt(,,,):ADתΪ AIN ֮ ѹֵ(mV)
//		ADC_VOLTAGE   = ADC_ConvVolt(Vref2, AIN7, Conv128CLK, ADC_Single);
//......................................................................................................
//------ADC_ConvCode(,,,):ADתΪ AIN ֮ ADC Code
		ADC_Code_READ = ADC_ConvCode(Vref2, AIN7, Conv128CLK, ADC_Single);
		//.........................|......|.....|...........| ADC_Single, ADC_Repeat
		//.........................|......|.....| Conv32CLK, Conv64CLK, Conv128CLK, Conv256CLK, Conv512CLK, Conv1024CLK
		//.........................|......|.....| (*עתʱӦ趨12.8 us ~ 128 us Χ)
		//.........................|......|.....| fcgck=16M... Conv256CLK(16us) ~ Conv1024CLK( 64us)
		//.........................|......|.....| fcgck= 8M... Conv128CLK(16us) ~ Conv1024CLK(128us)
		//.........................|......|.....| fcgck= 4M... Conv64CLK (16us) ~ Conv512CLK (128us)
		//.........................|......|.....| fcgck= 2M... Conv32CLK (16us) ~ Conv256CLK (128us)
		//.........................|......| AIN0~AIN8, VDD4_1, AIN_GND
		//.........................| Vref2, Vref3, Vref4, VDDVref, EXTVref
		// Ϊ AD תʱοֵFCGCK=16MHz,Conv256CLK(16us),Vref=2V
		// ad_test_times--Single(code)--Single(voltage)--Repeat(code)--Repeat(voltage)
		//       1      --  610us     --  269us        --  600us     --  240us
		//       2      --  750us     --  380us        --  655us     --  295us
		//       4      -- 1000us     --  630us        --  750us     --  390us
		//       8      -- 1480us     -- 1120us        --  950us     --  580us
		//      16      -- 2470us     -- 2100us        -- 1330us     --  970us
		P8DR.bit.b0 = 0;	// ۲ִʱ䣬ɾ

		data2Port[0] = ((ADC_Code_READ/100)%100);
		data2Port[1] = ((ADC_Code_READ/  1)%100);
	//	look_data(99); look_data(data2Port[0]); look_data(data2Port[1]);
		look_data(data2Port[0]); look_data(data2Port[1]);
//		ADC_VOLTAGE  = ((ulong)ADC_Code_READ * 2000) / 1024;	// ĿѹֵȽ, ѡڲ2Vοѹ
//		data2Port[0] = ((ADC_VOLTAGE/100)%100);
//		data2Port[1] = ((ADC_VOLTAGE/  1)%100);
//		look_data(data2Port[0]); look_data(data2Port[1]);

//		data2Port[0] = ((iReal_Vref2V/100)%100);
//		data2Port[1] = ((iReal_Vref2V/  1)%100);
//		look_data(88); look_data(data2Port[0]); look_data(data2Port[1]);
//		data2Port[0] = ((adc_GND/100)%100);
//		data2Port[1] = ((adc_GND/  1)%100);
//		look_data(0); look_data(data2Port[0]); look_data(data2Port[1]);
	}
//* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
}




//*********************************************************************
// 	: delay_times(uchar tBase, uint x)
// 	: ʱ
// ע		: ==> t_1ms   = 0;
// 			: ==> t_100us = 1;
// 			: ==> t_6u    = 2;	//HIRC: 8MHz, CGCR/4
// 			: ==> t_3u    = 3;	//HIRC:16MHz, CGCR/4
// 			: ...
//*********************************************************************
void delay_times(uchar tBase, uint x)
{
	uint  i, cgcrT;
//	uchar cgcrF[4]={ 2, 4,  8, 1 };		// HIRC =>  8MHz
	uchar cgcrF[4]={ 4, 8, 16, 2 };		// HIRC => 16MHz

	cgcrT = cgcrF[CGCR.byte];			// 0:fc/4, 1:fc/2, 2:fc/1, 3:fc/8
	switch(tBase){
		case 0:		// t_1ms
			cgcrT *= 110;
			for(; x>0; x--)
				for(i=0; i<cgcrT; i++){}
			break;
		case 1:		// t_100us
			cgcrT *= 11;
			for(; x>0; x--)
				for(i=0; i<cgcrT; i++){}
			break;
		case 2:		// t_6u				// HIRC: 8MHz, CGCR/4
			for(; x>0; x--){}
			break;
		case 3:		// t_3u				// HIRC:16MHz, CGCR/4
			for(; x>0; x--){}
			break;
	}
	WDCDR.byte=0x4e; 			// clear wdt
}


//*********************************************************************
// 	: look_data()
// 	: IO output data by IO_i2c
// ע		:
//	//-- Define IO port --//
//	#define	look_SDA				P9DR.bit.b0
//	#define	look_SCL				P9DR.bit.b1
//*********************************************************************
void look_data(uchar data)
{
	uchar iloop, x, z=10;

//	start condition......
	look_SDA = 1;		for(x=z; x>0; x--){}
	look_SCL = 1;		for(x=z; x>0; x--){}
	look_SDA = 0;		for(x=z; x>0; x--){}
	look_SCL = 0;		for(x=z; x>0; x--){}

//	sent byte data......
	for( iloop=0; iloop<8; iloop++ )
	{
		look_SDA = data >> 7;
		data     = data << 1;
						for(x=z; x>0; x--){}
		look_SCL = 1;	for(x=z; x>0; x--){}
		look_SCL = 0;	for(x=z; x>0; x--){}
	}
	look_SDA = 0;		for(x=z; x>0; x--){}
	look_SCL = 1;		for(x=z; x>0; x--){}
	look_SCL = 0;		for(x=z; x>0; x--){}

//	stop condition......
	look_SDA = 0;		for(x=z; x>0; x--){}
	look_SCL = 1;		for(x=z; x>0; x--){}
	look_SDA = 1;		for(x=z; x>0; x--){}
}


//*********************************************************************
// 	: XTAL_High_Config()
// 	: HIGH XTAL Sequence
// ע		:
//*********************************************************************
void XTAL_High_Config()
{
	__asm("DI");
	P7CR.bit.b1 = 1;		// ۿWUC״̬Ҳñ
	P7DR.bit.b1 = 1;		// ۿWUC״̬Ҳñ
	WUCCR.byte = 0x01;
	WUCDR.byte = 0x26;
	EIRL.bit.b4 = 1;
	P0FC.bit.b0 = 1;		// define P00 to XIN
	SYSCR2.bit.b6 = 1;		// enable start External osc(XEN=1) and WUC start count
	__asm("EI");
//	while( P7DR.bit.b1 ){}	// WUC ж趨Ϊ0
	SYSCR1.bit.b3 = 1;		// SYSCR1<OSCSEL>=1: Select the external high-frequency clock
	__asm("NOP");
	__asm("NOP");
	SYSCR2.bit.b7 = 1;		// SYSCR2<OSCHEN>=0: Stop the internal high-frequency clock.
}




